---
# Manage Keycloak client used for OpenTalk web-frontend
- name: Create or update Keycloak client {{ FRONTEND_CLIENT_ID | default('OtFrontend') }}
  community.general.keycloak_client:
    auth_keycloak_url: "{{ AUTH_KEYCLOAK_URL }}"
    auth_realm: "{{ AUTH_REALM | default('master') }}"
    auth_username: "{{ AUTH_USERNAME }}"
    auth_password: "{{ AUTH_PASSWORD }}"
    realm: "{{ KEYCLOAK_TARGET_REALM }}"
    client_id: "{{ FRONTEND_CLIENT_ID | default('OtFrontend') }}"
    name: "OpenTalk Frontend"
    admin_url: ""
    base_url: ""
    description: ""
    enabled: true
    public_client: true
    direct_access_grants_enabled: false
    service_accounts_enabled: false
    client_authenticator_type: client-secret
    redirect_uris: "{{ FRONTEND_CLIENT_REDIRECT_URIS }}"
    web_origins: "{{ FRONTEND_CLIENT_WEB_ORIGINS }}"
    attributes:
      client_credentials.use_refresh_token: false
      post.logout.redirect.uris: "+"
      display.on.consent.screen: false
      oauth2.device.authorization.grant.enabled: false
      backchannel.logout.revoke.offline.tokens: false
      use.refresh.tokens: true
      exclude.session.state.from.auth.response: false
    protocol_mappers:
      - config:
          full.path: true
          id.token.claim: true
          access.token.claim: true
          claim.name: x_grp
          userinfo.token.claim: true
        name: group membership
        protocol: openid-connect
        protocolMapper: oidc-group-membership-mapper
        consentRequired: false
      - config:
          aggregate.attrs: false
          multivalued: false
          userinfo.token.claim: true
          user.attribute: phone
          id.token.claim: true
          access.token.claim: true
          claim.name: phone_number
          jsonType.label: String
        name: phone number
        protocol: openid-connect
        protocolMapper: oidc-usermodel-attribute-mapper
        consentRequired: false
    default_client_scopes:
      - web-origins
      - phone
      - roles
      - profile
      - email
    optional_client_scopes:
      - address
      - offline_access
      - microprofile-jwt
    state: present
  tags:
    - client_frontend
